<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Kode"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Scope</label>

            <b-form-select
              v-model="filter.scope"
              :options="formattedScopeOptions"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Title</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Title"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Type</label>

            <b-form-select
              v-model="filter.type"
              :options="options.types"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Doc Type</label>

            <b-form-select
              v-model="filter.docType"
              :options="options.docTypes"
              size="lg"
            ></b-form-select>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md">
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="d-flex my-3 justify-content-start">
          <button
            class="btn btn-success btn-md"
            @click="showInputModal(null, 'Form Tambah Design')"
          >
            <i class="flaticon-add"></i> Tambah Design
          </button>
        </div>

        <complete-table :loading="loading" :data="designs">
          <template #header>
            <tr class="text-left">
              <th style="min-width: 250px" class="pl-7">
                <span class="text-dark-75">Code</span>
              </th>
              <th style="min-width: 100px">Title</th>
              <th style="min-width: 100px">Scope</th>
              <th style="min-width: 100px">Type</th>
              <th style="min-width: 101px">Aksi</th>
            </tr>
          </template>

          <template #defaultBody="{ item, i }">
            <tr v-bind:key="i">
              <td class="pl-0 ">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.code }}
                </span>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.title }}
                </span>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.scope ? item.scope.name : "-" }}
                </span>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.type ? item.type.name : "-" }}
                </span>
              </td>

              <td class="pr-0">
                <a
                  class="btn btn-light-success font-weight-bolder font-size-sm"
                  @click="showInputModal(item, 'Form Ubah Design', false)"
                >
                  <i class="flaticon-edit"></i>
                </a>

                <a
                  class="btn btn-light-danger font-weight-bolder font-size-sm ml-2"
                  @click="showDeleteModal(item)"
                >
                  <i class="flaticon-delete"></i>
                </a>
              </td>
            </tr>
          </template>
        </complete-table>

        <b-modal ref="input" hide-footer :title="title">
          <div class="d-block text-center">
            <form>
              <div class="row">
                <div class="col-md-12 py-2 col-sm-12 text-left">
                  <label for="input-large">Number *</label>

                  <b-form-input
                    id="input-large"
                    size="lg"
                    placeholder="Masukkan Number"
                    v-model="form.numbering"
                  ></b-form-input>
                </div>

                <div class="col-md-12 py-2 col-sm-12 text-left">
                  <label for="input-large">Title *</label>

                  <b-form-input
                    id="input-large"
                    size="lg"
                    placeholder="Masukkan Title"
                    v-model="form.title"
                  ></b-form-input>
                </div>

                <div class="col-md-12 py-2 col-sm-12 text-left">
                  <label for="input-large">Scope *</label>

                  <b-form-select
                    v-model="form.scope"
                    :options="formattedScopeOptions"
                    size="lg"
                  ></b-form-select>
                </div>

                <div class="col-md-12 py-2 col-sm-12 text-left">
                  <label for="input-large">Type *</label>

                  <b-form-select
                    v-model="form.type"
                    :options="options.types"
                    size="lg"
                  ></b-form-select>
                </div>

                <div class="col-md-12 py-2 col-sm-12 text-left">
                  <label for="input-large">Kategori *</label>

                  <b-form-select
                    v-model="form.category"
                    :options="options.categories"
                    size="lg"
                  ></b-form-select>
                </div>

                <div class="col-md-12 py-2 col-sm-12 text-left">
                  <label for="input-large">Numbering Type *</label>

                  <b-form-select
                    v-model="form.numbering_type"
                    :options="options.numberingTypes"
                    size="lg"
                  ></b-form-select>
                </div>
              </div>
            </form>

            <div class="d-flex mt-2">
              <b-button
                :disabled="loading"
                class="btn btn-success mr-2"
                block
                @click="isCreate ? saveDesign() : updateDesign()"
              >
                Simpan
              </b-button>

              <b-button
                :disabled="loading"
                class="btn btn-secondary mt-0"
                block
                @click="closeInputModal"
              >
                Batal
              </b-button>
            </div>
          </div>
        </b-modal>

        <b-modal ref="delete" hide-footer title="Warning">
          <div class="d-block text-center">
            <div class="row">
              <div class="col-md-12 py-2 col-sm-12 text-left">
                <label for="input-large">Design Akan Dihapus</label>
              </div>
            </div>
            <div class="d-flex mt-2">
              <b-button
                :disabled="loading"
                class="btn btn-success mr-2"
                @click="deleteDesign"
                block
              >
                Hapus
              </b-button>

              <b-button
                class="btn btn-secondary mt-0"
                block
                @click="closeDeleteModal"
                :disabled="loading"
              >
                Batal
              </b-button>
            </div>
          </div>
        </b-modal>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { mapState } from "vuex";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import {
  DELETE_DESIGN,
  GET_DESIGN,
  SAVE_DESIGN,
  UPDATE_DESIGN
} from "../../../core/services/store/design.module";
import { GET_SCOPES } from "../../../core/services/store/scope.module";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";

export default {
  name: "Design",
  components: { CompleteTable },
  data() {
    return {
      currentItem: null,
      title: null,
      form: {
        numbering: null,
        code: null,
        title: null,
        type: null,
        scope: null,
        numbering_type: null,
        general: null,
        category: null
      },
      filter: {
        number: null,
        title: null,
        docType: null,
        scope: null,
        type: null
      },
      options: {
        docTypes: [
          {
            value: null,
            text: "Pilih Tipe Dokumen"
          },
          {
            value: "bom",
            text: "BOM"
          }
        ],
        scopes: [
          {
            value: null,
            text: "Pilih Scope"
          },
          {
            value: "hmi",
            text: "HMI"
          }
        ],
        categories: [
          {
            value: null,
            text: "Pilih Kategori"
          },
          {
            value: "BOM",
            text: "BOM"
          }
        ],
        numberingTypes: [
          {
            value: null,
            text: "Pilih Tipe Numbering"
          },
          {
            value: "gen",
            text: "gen"
          },
          {
            value: "oto",
            text: "oto"
          }
        ],
        types: [
          {
            value: null,
            text: "Pilih Tipe"
          },
          {
            value: "software",
            text: "Software"
          },
          {
            value: "drawing",
            text: "Drawing"
          }
        ]
      },
      data: {
        designs: [
          {
            number: "GEN-F95-100000",
            title: "BOM Desain Circuit",
            scope: "General",
            type: "Document"
          }
        ]
      }
    };
  },
  computed: {
    ...mapState({
      loading: state => state.design.loading,
      designs: state => state.masterDesign.designs?.data,
      scopes: state => state.scope.scopes?.data
    }),

    formattedScopeOptions() {
      let scopes = [];

      if (arrayMoreThanOne(this.scopes)) {
        scopes = this.scopes.map(scope => {
          return {
            value: scope.code,
            text: scope.name
          };
        });
      }

      return [{ value: null, text: "Pilih Bagian" }, ...scopes];
    }
  },
  methods: {
    getDesigns(filter = false) {
      if (!arrayMoreThanOne(this.designs) || filter) {
        this.$store.dispatch(GET_DESIGN, {
          params: {}
        });
      }
    },

    getScopes() {
      if (!arrayMoreThanOne(this.scopes)) {
        this.$store.dispatch(GET_SCOPES, {
          params: {}
        });
      }
    },

    showInputModal(item, title, isCreate = true) {
      this.item = item;

      this.title = title;

      this.isCreate = isCreate;

      this.form = {
        code: item?.code ?? null,
        numbering: item?.numbering ?? null,
        title: item?.title ?? null,
        type: item?.type?.code ?? null,
        scope: item?.scope?.code ?? null,
        numbering_type: item?.numbering_type ?? null,
        general: item?.general,
        category: item?.category?.code ?? null
      };

      this.$refs["input"].show();
    },

    closeInputModal() {
      this.$refs["input"].hide();
    },

    showDeleteModal(item) {
      this.currentItem = item;

      this.$refs["delete"].show();
    },

    closeDeleteModal() {
      this.$refs["delete"].hide();
    },

    saveDesign() {
      this.$store.dispatch(SAVE_DESIGN, this.formatForm()).then(() => {
        this.closeInputModal();
      });
    },

    updateDesign() {
      this.$store.dispatch(UPDATE_DESIGN, this.formatForm()).then(() => {
        this.closeInputModal();
      });
    },

    deleteDesign() {
      this.$store
        .dispatch(DELETE_DESIGN, {
          code: this.currentItem?.code
        })
        .then(() => {
          this.closeDeleteModal();
        });
    },

    formatForm() {
      const scope = this.formattedScopeOptions.find(
        scope => scope.value === this.form.scope
      );

      const type = this.formattedScopeOptions.find(
        scope => scope.value === this.form.scope
      );

      const category = this.formattedScopeOptions.find(
        scope => scope.value === this.form.scope
      );

      return {
        ...this.form,
        code: this.currentItem?.code ?? this.form.numbering,
        scope: {
          name: scope?.text,
          code: scope?.value
        },
        type: {
          name: type?.text,
          code: type?.value
        },
        category: {
          name: category?.text,
          code: category?.value
        },
        general: this.currentItem?.general ?? 0
      };
    }
  },
  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Design" }]);

    this.getDesigns();

    this.getScopes();
  }
};
</script>

<style></style>
